#!/usr/bin/env python3

from flask import Flask, render_template
from random import randint, choice
app = Flask(__name__)

def bullshit_video(nested = False):
    frags = {
        "start" : ["motion-adaptive", "temporal", "spatial", "edge-guided",
                   "high-quality", "fast", "detail-preserving"],
        "word" : ["deinterlacing", "interpolation", "anti-aliasing",
                  "line darkening", "warp sharpening", "sharpening",
                  "smoothing", "debanding", "gradient smoothing", "deblocking",
                  "dehaloing", "edge enhancement", "deringing", "deblending",
                  "bobbing", "decombing", "denoising", "field matching",
                  "decimation", "inverse telecine", "logo removal"],
        "with" : ["contra-sharpening", "edge masking", "temporal stabilization"]
    }
    string = []

    for i in range(randint(1,3)):
        string.append(frags["start"].pop(randint(0, len(frags["start"]) - 1)))

    if "spatial" in string and "temporal" in string:
        string.remove("spatial")
        string.remove("temporal")
        string.append("spatio-temporal")

    string.append(frags["word"].pop(randint(0, len(frags["word"]) - 1)))

    if not nested:
        for i in range(randint(0,1)):
            string.append("with")
            string.extend(choice([bullshit_video(True), [frags["with"].pop(randint(0, len(frags["with"]) - 1))]]))

    return string

@app.route('/doom9')
def doom9():
    return render_template("bullshit.html", bullshit=" ".join(bullshit_video()))

@app.route('/och')
def och():
    frags = {
        "pre" : ["Cloud",
                 "Drop",
                 "Exa",
                 "Fast",
                 "File",
                 "Hot",
                 "i",
                 "Media",
                 "Mega",
                 "My",
                 "Rapid",
                 "Send",
                 "Share",
                 "Sky",
                 "Smart",
                 "Super",
                 "Turbo",
                 "Ultra",
                 "Up",
                 "Web",
                 "X",
                 "You",
                 "Z"],
        "sep" : [" ", "", "-"],
        "suf" : ["Base",
                 "Box",
                 "Cloud",
                 "Dir",
                 "Drive",
                 "File",
                 "Fire",
                 "Gator",
                 "Get",
                 "Host",
                 "Load",
                 "Me",
                 "Online",
                 "Safe",
                 "Serv",
                 "Serve",
                 "Share",
                 "Sonic",
                 "Station",
                 "Storage",
                 "Up",
                 "Upload",
                 "Vault"]
    }

    fonts = ["font-family: 'Aldrich', sans-serif;",
             "font-family: 'Capriola', sans-serif;",
             "font-family: 'Concert One', cursive;",
             "font-family: 'Doppio One', sans-serif;",
             "font-family: 'Geo', sans-serif;",
             "font-family: 'Jockey One', sans-serif;",
             "font-family: 'Jura', sans-serif;",
             "font-family: 'Michroma', sans-serif;",
             "font-family: 'Nova Flat', cursive;",
             "font-family: 'Nova Round', cursive;",
             "font-family: 'Quantico', sans-serif;",
             "font-family: 'Russo One', sans-serif;",
             "font-family: 'Squada One', cursive;",
             "font-family: 'Supermercado One', cursive;"]

    name = choice(frags["pre"]) + choice(frags["sep"]) + choice(frags["suf"])
    font = choice(fonts)

    return render_template("och.html", name=name, font=font)

@app.route('/')
def bullshit():
    frags = {
        "start" : ["agile", "advanced", "leveraged", "extended", "basic",
                   "open-source", "private", "flexible", "patented",
                   "abstract", "stateless", "optimized", "virtualized",
                   "extensible", "compliant", "scale-out", "generic", "mobile",
                   "secure", "overflow-preventing", "non-blocking",
                   "ISO-certified", "encrypted", "proven", "open", "RESTful",
                   "content-addressed", "asynchronous", "object-oriented",
                   "anonymous", "transactional", "distributed",
                   "structured", "managed", "webscale", "virtual", "shared",
                   "stable", "intelligent", "industry-standard",
                   "industry-leading", "interactive", "innovative",
                   "high-impact", "award-winning", "touch-enabled",
                   "patent-pending", "server-side", "client-side", "turnkey",
                   "enterprise-grade", "simple", "clustered", "high powered",
                   "customizable", "pluggable", "on-premise", "cross-platform"],
        "word" : ["cloud", "grid", "base", "metadata", "replication",
                  "factory", "strategy", "interface", "singleton", "framework",
                  "cache", "template", "API", "service", "event", "rails",
                  "firewall", "standard", "shader", "hardware", "software",
                  "database", "descriptor", "hypervisor", "method", "table",
                  "package", "plugin", "browser", "extension", "module",
                  "proxy", "hosting", "wrapper", "storage", "component",
                  "markup", "workflow", "tile", "data"],
        "suffix" : ["-oriented", "-based", "-aware", "-agnostic", "-optimized"],
        "noend" : ["configuration", "information", "NoSQL", "persistence",
                   "scripting", "real-time", "just-in-time", "polling",
                   "dependency injection", "pipelining", "GPGPU", "compute shader",
                   "core", "rich-client", "DOM", "WebGL", "WebAssembly",
                   "CSS", "CMS", "STM", "map/reduce", "callback",
                   "lifecycle", "session", "content-driven", "high-performance",
                   "general-purpose", "out-scaling", "property", "element",
                   "dependency", "validation", "SEO", "ROI", "continuous delivery",
                   "business intelligence", "WYSIWYG", "data mining",
                   "reporting", "cryptocurrency", "blockchain", "Node.js",
                   "JavaScript", "IP lifecycle", "IoT", "in-memory",
                   "data visualization", "machine learning", "ingestion",
                   "cost of ownership", "SaaS", "PaaS", "cloud computing"],
        "acronym" : ["JSON", "XML", "SOAP",
                     "ORM", "SSL", "HTTP", "HLS", "RTMP"],
        "end" : ["layer", "manager", "frontend", "backend", "control",
                 "controller", "framework", "database", "generator",
                 "optimizer", "interface", "solution",
                 "application", "platform", "provider", "dashboard"]
        }

    string = []

    for i in range(randint(1,2)):
        string.append(frags["start"].pop(randint(0, len(frags["start"]) - 1)))

    for i in range(randint(0,3)):
        word = frags["word"].pop(randint(0, len(frags["word"]) - 1))
        word = word + frags["suffix"].pop(randint(0, len(frags["suffix"]) - 1))

    for i in range(randint(0,1)):
        string.append(frags["acronym"].pop(randint(0, len(frags["acronym"]) -1)))
        for i in range(randint(0,1)):
            string.append("over " + choice(frags["acronym"]))

    for i in range(randint(0,1)):
        string.append(choice(frags["noend"]))

    for i in range(randint(1,2)):
        string.append(frags["end"].pop(randint(0, len(frags["end"]) - 1)))

    return render_template("bullshit.html", bullshit=" ".join(string))

if __name__ == '__main__':
    app.debug = True
    app.run()
